package scalatest.guide.ch06tagging

import collection.mutable.Stack
import org.scalatest._

class StackSpec extends flatspec.AnyFlatSpec with matchers.should.Matchers {

  "A Stack" should "pop values in last-in-first-out order" in {
    @com.github.ghik.silencer.silent("deprecated")
    val stack = new Stack[Int]
    stack.push(1)
    stack.push(2)
    stack.pop() should be(2)
    stack.pop() should be(1)
  }

  it should "throw NoSuchElementException if an empty stack is popped" ignore {
    @com.github.ghik.silencer.silent("deprecated")
    val emptyStack = new Stack[Int]
    a[NoSuchElementException] should be thrownBy {
      emptyStack.pop()
    }
  }
}
