package scalatest.guide.ch08fixtures

import org.scalatest._
import java.io._

class Ex05OneArgFixtureExampleSpec extends flatspec.FixtureAnyFlatSpec {

  case class FixtureParam(file: File, writer: FileWriter)

  def withFixture(test: OneArgTest) = {
    val file       = File.createTempFile("hello", "world") // create the fixture
    val writer     = new FileWriter(file)
    val theFixture = FixtureParam(file, writer)

    try {
      writer.write("ScalaTest is ")             // set up the fixture
      withFixture(test.toNoArgTest(theFixture)) // "loan" the fixture to the test
    } finally writer.close()                    // clean up the fixture
  }

  "Testing" should "be easy" in { f =>
    f.writer.write("easy!")
    f.writer.flush()
    assert(f.file.length === 18)
  }

  it should "be fun" in { f =>
    f.writer.write("fun!")
    f.writer.flush()
    assert(f.file.length === 17)
  }
}
